// #######################################################################
// ### Liste.java                                                      ###
// ### Liste zur Verwaltung von Datenobjekten                          ###
// ### Verantwortlich: Thomas Dreibholz, Dreibholz@bigfoot.com         ###
// #######################################################################


package puma.database;


import java.io.*;
import java.util.*;

// import Datenobjekt;


// ****** Liste **********************************************************
public class Liste
{
   private Vector daten   = new Vector();
   private int    aktuell = 0;


   // ###### Konstruktor #################################################   
   public Liste() { }

      
   // ###### Liste leeren ################################################
   public void Neu() {
      daten   = new Vector();
      aktuell = 0;
   }

   
   // ###### Datenobjekt anfgen #########################################
   public void Anfuegen(Datenobjekt x) {
      daten.addElement(x);
   }


   // ###### Datenobjekt "name" lschen ##################################
   public void Loeschen(String name) {
      for(int i = 0;i < daten.size();i++) {
         if(name.equals(Element(i).Beschreibung())) {
            daten.removeElementAt(i);
            aktuell = 0;
            break;
         }
      }
   }   


   // ###### Datenobjekt "name" suchen ###################################
   public Datenobjekt Suchen(String name) throws NoSuchElementException {
      for(int i = 0;i < daten.size();i++) {
         if(name.equals(Element(i).Beschreibung())) {
            return(Element(i));
         }
      }
      throw new NoSuchElementException(); 
   }   

   
   // ###### Ausgabe #####################################################
   public void Ausgabe() {
      for(int i = 0;i < daten.size();i++) {
         Element(i).Ausgabe();
      }
   }


   // ###### Umwandlung in String ########################################
   public String toString() {
      String s = "";
      for(int i = 0;i < daten.size();i++) {
         s = s + Element(i).toString() + "\n";
      }
      return(s);      
   }                                 

   
   // ###### Block aus Liste extrahieren #################################
   public Liste ExtrahiereBlock(int block) throws ArrayIndexOutOfBoundsException {
      // Vorhergehende Blcke berspringen
      int zaehler = 0;
      for(int i = 0;i < block;i++) {
         while(Element(zaehler).Inhalt() != null) {
            zaehler++;
         }
         zaehler++;         
      }

      // Block kopieren      
      Liste neu = new Liste();
      try {
         while(Element(zaehler).Inhalt() != null) {
            neu.Anfuegen(Element(zaehler));
            zaehler++;
         }
      } catch(ArrayIndexOutOfBoundsException e) { }   
      return(neu);
   }


   // ###### Vergleich zweier Blcke #################################
   static public boolean VergleicheBloecke(Liste b1, Liste b2) {
      if(b1.daten.size() == b2.daten.size()) {
         Datenobjekt x = null, y = null;
         for(int i = 0;i < b1.daten.size();i++) {
            try {
               x = (Datenobjekt)b1.daten.elementAt(i);
               y = b2.Suchen(x.Beschreibung());
            } catch(NoSuchElementException e) {
               return(false);
            }   
            if(!x.EingabeTyp().equals(y.EingabeTyp()))
               return(false);
            if(!x.Inhalt().equals(y.Inhalt()))
               return(false);
         }   
         return(true);
      }
      return(false);      
   }


   // ###### Vergleich mit anderer Liste #################################
   public boolean equals(Liste vergleich) {
      if(daten.size() == vergleich.daten.size()) {
         try {
            for(int block = 0;;block++) {
               if(!VergleicheBloecke(ExtrahiereBlock(block),vergleich.ExtrahiereBlock(block)))
                  return(false);
             }       
         } catch(ArrayIndexOutOfBoundsException e) {  }
         return(true);
      }
      return(false);      
   }
   
     
   // ###### Erstes Element zurckliefern ################################
   Datenobjekt ErstesElement() throws NoSuchElementException {
      aktuell = 0;
      return((Datenobjekt)daten.firstElement());
   }


   // ###### Nchstes Element zurckliefern ##############################
   Datenobjekt NaechstesElement() throws NoSuchElementException {
      aktuell++;
      return((Datenobjekt)daten.elementAt(aktuell));
   }

   
   // ###### Anzahl der Elemente in der Liste ############################
   public int Anzahl() {
      return(daten.size());
   }

   
   // ###### Datenobjekt an Position i zurckliefern ###########################
   public Datenobjekt Element(int i) throws ArrayIndexOutOfBoundsException {
      return((Datenobjekt)daten.elementAt(i));
   }
}
