package puma.control;

import java.util.Vector;
import puma.database.*;

/** Kapselt die Statusnderung in der Datenbank fr eine Menge von Instanzen.. 
 *  @author Sven Mller
 */
public class I_StatusAendern {
   /** Array von Inventar-Nummern.
    */
   protected int[] invNr;
   /** Neuer Status-Bezeichner
    */
   protected String newState;
   /** ID eines mglichen neuen Benutzers
    */
   protected int personID = 0;
   
   /** Standard-Konstruktor
    *  @param invNr Array von Inventarnummern
    *  @param newState Status-Bezeichner
    *  @param newUser Benutzername eines neuen Benutzers.
    *  @exception puma.database.OperationException Falls bei Suche nach PersonID zu
    *  newUser ein Fehler auftritt.
    */
   public I_StatusAendern(int[] invNr, String newState, int newUserID)
          throws OperationException {
      this.invNr = invNr;
      this.newState = newState;
      personID = newUserID;
   }
   
   /** Ausfhren der Datenbank-nderungsaktionen.
    *  @return Vector mit Ergebnis- bzw. Fehlermeldungen
    */
   public Vector execute() {
   	Vector messages = new Vector();
   	
   	for (int i=0; i<invNr.length; i++) 
         try {        	  		
            Operationen.getInstance().
               instanzStatusAendern(invNr[i],newState,personID);
            messages.addElement(new String(invNr[i]+" Statusnderung erfolgreich."));
         } catch (Exception e) {messages.addElement(
           new String("Fehler bei InvNr. "+invNr[i]+": "+e.toString() )); }         	
      return messages;
   }
   
}
