package puma.control;

import java.util.Vector;
import puma.database.*;

/** Dieses Interface umfasst all diese Methoden, die einen Output (des
 * DBMS) im Verarbeitungsschritt in das Rckgabeformat umwandeln bzw.
 * in einen greren Kontext einfgen.
 * @author Sven Mller
 */

public interface OutType { 
   /** Erzeugt die Ausgabe eines Suchergebnisses, das als Liste von
    *  von Publikationen vorliegt.Optional wird eine Selektionsmglichkeit
    *  geboten.
    */
   void setPublikationArray(Liste publikationen, boolean canSelect);
   
   /** Erzeugt die Ausgabe eines Suchergebnisses von Instanzen, das als
    *  eine Liste dieser Instanzen vorliegt.
    */    
   void setInstanzArray(Liste instanzen);
   
   /** Erzeugt die Ausgabe einer Ausleihliste fr einen bestimmten Benutzer.
    *  Ferner wird Verzweigungsmglichkeit zu Liste bzgl. anderer Benutzer
    *  geboten
    */    
   void setAusleihliste(Liste instanzen, StringListeDaten user);
   
   /** Erzeugt die Ausgabe einer Liste von Meldungen, die als Vector von
    *  Strings bergeben werden.
    */
   void setMessageArray(Vector messages); 
   
   /** Erzeugt eine simple Fehlermeldung anhand einer bergebenen Exception-
    * Instanz.
    */
   void createErrorMsg(Exception e);
}
